<template>
  <div>
    <v-row class="navQuestions my-4 mx-8" align="center" no-gutters>
      <span style="font-size: 0.9rem"><b>Filtrar por:</b></span>
      <v-select
        class="mx-3"
        style="max-width: 16%;"
        dense
        v-model="selectedFilter"
        flat
        hide-no-data
        hide-details
        item-text="name"
        item-value="value"
        :items="filterAutoComplete"
      ></v-select>
      <!-- caso opte por busca por área -->
      <v-select
        v-if="selectedFilter == 'byArea'"
        class="mx-3"
        style="max-width: 16%;"
        dense
        v-model="selectedArea"
        label="Escolha a área"
        flat
        hide-no-data
        hide-details
        item-text="name"
        item-value="id"
        :items="filterAreas"
      ></v-select>
      <v-spacer />
      <v-btn small color="primary" class="mr-4" elevation="0" @click="handleNewQuestion">
        Nova Questão
        <v-icon small right class="ml-3">mdi-plus</v-icon>
      </v-btn>
    </v-row>
    <!-- Tabela -->
    <v-data-table
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headers"
      :items="questions"
      :footer-props="{
        itemsPerPageText: 'Questões por página',
        itemsPerPageOptions: [20, 50, -1],
      }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable">
          <v-tooltip bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleViewQuestion(item)">mdi-eye</v-icon>
            </template>
            <span><b>Ver</b> questão</span>
          </v-tooltip>
          <v-tooltip
            v-if="
              userRole == 'admin' ||
                selectedFilter == 'myQuestions' ||
                (item.author && item.author.id == userInfo.id)
            "
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleEditQuestion(item)">mdi-pencil</v-icon>
            </template>
            <span><b>Editar</b> questão</span>
          </v-tooltip>
          <v-tooltip
            v-if="
              userRole == 'admin' ||
                selectedFilter == 'myQuestions' ||
                (item.author && item.author.id == userInfo.id)
            "
            bottom
            color="primary"
          >
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleDeleteQuestion(item)">mdi-delete</v-icon>
            </template>
            <span><b>Deletar</b> questão</span>
          </v-tooltip>
        </div>
      </template>
      <!-- titulo -->
      <template v-slot:[`item.title`]="{ item }">
        <v-tooltip bottom color="primary">
          <template v-slot:activator="{ on }">
            <span v-on="on" class="viewQuestionStyle" @click="handleViewQuestion(item)">{{
              item.title
            }}</span>
          </template>
          <span><b>Ver</b> questão</span>
        </v-tooltip>
        <v-icon
          class="ml-1"
          v-if="item.author && item.author.id == userInfo.id"
          x-small
          color="primary"
        >
          mdi-star
        </v-icon>
      </template>
      <!-- Tipo questão -->
      <template v-slot:[`item.questionType`]="{ item }">
        {{ showQuestionType(item.questionType) }}
      </template>
      <!-- Dificuldade -->
      <template v-slot:[`item.difficulty`]="{ item }">
        {{ showDifficultyType(item.difficulty) }}
      </template>
      <!-- Autor -->
      <template v-slot:[`item.author`]="{ item }">
        <span v-if="item.author"> {{ item.author.name }} {{ item.author.surname }} </span>
        <span v-else>{{ userInfo.name }} {{ userInfo.surname }}</span>
      </template>
      <!-- Visibilidade -->
      <template v-slot:[`item.visibility`]="{ item }">
        {{ showVisibilityType(item.visibility) }}
      </template>
      <!-- Área -->
      <template v-slot:[`item.area`]="{ item }">
        <div style="line-height: 1.1rem">
          <span
            style="font-size: 0.8rem; font-weight: 500;"
            v-for="(areaId, index) in item.area"
            :key="index"
          >
            {{ showNameOfArea(areaId) }}
            <span v-if="index != item.area.length - 1"><br /></span>
          </span>
        </div>
      </template>
    </v-data-table>

    <!-- INICIO DOS DIALOGS -->
    <v-dialog
      v-model="dialogViewQuestion"
      width="800px"
      @keydown.esc="closeDialogViewQuestion"
      @click:outside="closeDialogViewQuestion"
    >
      <ReadQuestion :areas="areas" :question="itemToView" @handleClose="closeDialogViewQuestion" />
    </v-dialog>
    <v-dialog
      v-model="dialogManageQuestion"
      width="800px"
      @keydown.esc="closeDialogManageQuestion"
      @click:outside="closeDialogManageQuestion"
    >
      <ManageQuestion
        ref="refManage"
        :type="manageQuestion"
        :itemToEdit="itemToEdit"
        :areas="areas"
        @handleClose="closeDialogManageQuestion"
        @addQuestion="addQuestionServer"
        @editQuestion="editQuestionServer"
      />
    </v-dialog>
    <!-- Confirma deletar usuario -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDeleteQuestion"
    />
  </div>
</template>

<script>
import ReadQuestion from './ReadQuestion.vue'
import ManageQuestion from './ManageQuestion.vue'
import Teacher from '../../../servicesEhq/req/teacher'

export default {
  name: 'Questions',
  props: {
    userRole: { type: String, default: '' },
  },
  computed: {},
  components: {
    ReadQuestion,
    ManageQuestion,
  },
  data: () => ({
    headers: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '20%' },
      { text: 'Área', align: 'center', sortable: false, value: 'area', width: '15%' },
      {
        text: 'Tipo de Questão',
        align: 'center',
        sortable: false,
        value: 'questionType',
        width: '10%',
      },
      { text: 'Dificuldade', align: 'center', sortable: false, value: 'difficulty', width: '10%' },
      { text: 'Autor', align: 'center', sortable: false, value: 'author', width: '20%' },
      { text: 'Visibilidade', align: 'center', sortable: false, value: 'visibility', width: '15%' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '15%' },
    ],
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    questions: [],
    filterAutoComplete: [
      { name: 'Minhas Perguntas', value: 'myQuestions' },
      { name: 'Todas perguntas públicas do banco', value: 'allQuestions' },
      { name: 'Por área', value: 'byArea' },
    ],
    selectedFilter: 'myQuestions',
    filterAreas: [],
    selectedArea: '',
    showOnlyOwnAnswers: false,
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    itemToView: {},
    itemToEdit: {},
    manageQuestion: 'add', //add or edit
    dialogViewQuestion: false,
    dialogManageQuestion: false,
    areas: [],
    userInfo: [],
  }),
  async created() {
    this.userInfo = await this.$getItem('userEHQ')
    await this.getAreas()
    await this.init()
  },
  watch: {
    async selectedFilter() {
      if (this.selectedFilter == 'myQuestions') await this.init()
      if (this.selectedFilter == 'allQuestions') await this.readPublicQuestions()
      if (this.selectedFilter == 'byArea') {
        this.filterAreas = this.areas
      }
    },
    async selectedArea() {
      await this.readQuestionsByArea(this.selectedArea)
    },
  },
  methods: {
    // FRONTEND BÁSICO
    showQuestionType(type) {
      //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
      if (type == 'objective') return 'Multipla Escolha'
      if (type == 'summation') return 'Somatório'
      if (type == 'multipleChoice') return 'Multipla Escolha Multi-Resposta'
      if (type == 'trueOrFalse') return 'Verdadeiro ou Falso'
      if (type == 'dissertation') return 'Dissertativa'
    },
    showDifficultyType(item) {
      if (item == 'easy') return 'Fácil'
      if (item == 'medium') return 'Médio'
      if (item == 'hard') return 'Difícil'
    },
    showVisibilityType(item) {
      if (item == 'public') return 'Público'
      if (item == 'private') return 'Privado'
    },

    showNameOfArea(id) {
      for (let i = 0; i < this.areas.length; i++) {
        if (this.areas[i].id == id) return this.areas[i].name
      }
      return 'Category not found'
    },

    // deletar questão
    handleDeleteQuestion(item) {
      this.itemToDelete = item
      this.alert.message = `Deseja <b>deletar</b> a questão "${item.title}" ?`
      this.alert.status = true
    },
    confirmDeleteQuestion() {
      this.alert.status = false
      let teacherId = this.userInfo.id
      if (this.itemToDelete.author) teacherId = this.itemToDelete.author.id
      this.deleteQuestion(teacherId, this.itemToDelete.id)
    },

    //ver questão
    handleViewQuestion(item) {
      this.itemToView = item
      this.dialogViewQuestion = true
    },
    closeDialogViewQuestion() {
      this.dialogViewQuestion = false
    },

    //nova questão
    handleNewQuestion() {
      this.manageQuestion = 'add'
      this.dialogManageQuestion = true
    },

    //editar questão
    handleEditQuestion(item) {
      this.itemToEdit = item
      this.manageQuestion = 'edit'
      this.dialogManageQuestion = true
    },

    // métodos p/ nova questão e editar questão
    closeDialogManageQuestion() {
      this.$refs.refManage.resetData()
      this.dialogManageQuestion = false
      this.manageQuestion = 'add'
      this.itemToEdit = {}
    },

    //métodos vindos do componente: MANAGE QUESTION
    addQuestionServer(question) {
      question.author = this.userInfo.id
      this.newQuestion(question)
    },
    async editQuestionServer(id) {
      if (this.selectedFilter == 'myQuestions') await this.init()
      if (this.selectedFilter == 'allQuestions') await this.readPublicQuestions()
      if (this.selectedFilter == 'byArea') {
        if (this.selectedArea) await this.readQuestionsByArea(this.selectedArea)
      }
    },

    /// INTEGRAÇÃO

    //init = lê suas proprias perguntas
    async init() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const user = await this.$getItem('userEHQ')
        let req = await Teacher.readQuestionsByTeacher(user.id)
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readPublicQuestions() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.readPublicQuestions()
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readQuestionsByArea(areaId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.readQuestionsByArea(areaId)
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async getAreas() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.getAllAvailableAreas()
        if (req.success) this.areas = req.data
      } catch (e) {
        console.error(e)
      } finally {
      }
    },

    async newQuestion(data) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.newQuestion(data)
        if (req.success) this.init()
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async deleteQuestion(teacherId, questionId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.deleteQuestion(teacherId, questionId)
        if (req.success) {
          if (this.selectedFilter == 'myQuestions') await this.init()
          if (this.selectedFilter == 'allQuestions') await this.readPublicQuestions()
          if (this.selectedFilter == 'byArea') {
            if (this.selectedArea) await this.readQuestionsByArea(this.selectedArea)
          }
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}
</style>
